// Copyright 2004-2006, IDesign
// www.idesign.net

using System;
using System.Collections.Generic;
using System.Text;

namespace Infrastructure.CrossCutting.Resource
{
    public class DisposableBaseType : IDisposable
    {
        private bool _disposed;
        protected bool Disposed
        {
            get
            {
                lock (this)
                {
                    return _disposed;
                }
            }
        }

        #region IDisposable Members

        public void Dispose()
        {
            lock (this)
            {
                if (_disposed == false)
                {
                    Cleanup();
                    _disposed = true;

                    GC.SuppressFinalize(this);
                }
            }
        }

        #endregion

        protected virtual void Cleanup()
        {
            // override to provide cleanup
        }

        ~DisposableBaseType()
        {
            Cleanup();
        }

    }

}
