﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Domain.MainModule.Entities;
using Infrastructure.Data.Core;
using Domain.MainModule.Repositories;
using Infrastructure.Data.MainModule.UnitOfWork;

namespace Infrastructure.Data.MainModule.Repositories
{
    public class BlurbRepository : Repository<Blurbs, int>, IBlurbRepository
    {
        public BlurbRepository(IQueryableUnitOfWork unitOfWork) : base(unitOfWork) { }

        public override Blurbs Get(int id)
        {
            var context = this.UnitOfWork as MainModuleUnitOfWork;
            if (context != null)
            {
                return context.CreateSet<Blurbs>().Find(id);
            }
            return null;
        }
    }
}
