﻿using Domain.MainModule.Entities;
using Domain.MainModule.Repositories;
using Infrastructure.Data.Core;
using Infrastructure.Data.MainModule.UnitOfWork;

namespace Infrastructure.Data.MainModule.Repositories
{
    public class RSVPRepository : Repository<RSVPs,int>, IRSVPRepository
    {
        public RSVPRepository(IQueryableUnitOfWork unitOfWork) : base(unitOfWork) { }

        public override RSVPs Get(int id)
        {
            var context = this.UnitOfWork as MainModuleUnitOfWork;
            if (context != null)
            {
                return context.CreateSet<RSVPs>().Find(id);
            }
            return null;
        }
    }
}
