﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Reflection;
using System.Web;

namespace Presentation.Web.UI.ActionResults
{
    public static class ActionResultHelper
    {
        public static string[] MontaCabecalho(object firstRow)
        {
            Type type = firstRow.GetType();
            string[] headers = type.GetProperties().Where(IsScaffoldColumn).Select(p => p.Name).ToArray();

            return headers;
        }

        public static bool IsScaffoldColumn(PropertyInfo pf)
        {
            if (pf.IsDefined(typeof(ScaffoldColumnAttribute), true))
            {
                var scaffold = (ScaffoldColumnAttribute)pf.GetCustomAttributes(typeof(ScaffoldColumnAttribute), true)[0];
                return scaffold.Scaffold;
            }

            return false;
        }

    }
}