﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Web.Mvc;
using DDay.iCal;
using DDay.iCal.Serialization.iCalendar;
using Domain.MainModule.Entities;
using Presentation.Web.UI.Helpers;

namespace Presentation.Web.UI.ActionResults
{
    class iCalResult : FileResult
    {
        public List<Dinners> Dinners { get; set; }

        public iCalResult(string filename) : base("text/calendar")
        {
            this.FileDownloadName = filename;
        }

        public iCalResult(List<Dinners> dinners, string filename) : this(filename)
        {
            this.Dinners = dinners;
        }

        public iCalResult(Dinners dinner, string filename) : this(filename)
        {
            this.Dinners = new List<Dinners>();
            this.Dinners.Add(dinner);
        }

        protected override void WriteFile(System.Web.HttpResponseBase response)
        {
            iCalendar iCal = new iCalendar();
            foreach (Dinners d in this.Dinners)
            {
                try
                {
                    Event e = CalendarHelpers.DinnerToEvent(d, iCal);
                    iCal.Events.Add(e);
                }
                catch (ArgumentOutOfRangeException)
                { 
                    //Swallow folks that have dinners in 9999. 
                }
            }

            iCalendarSerializer serializer = new iCalendarSerializer(iCal);
            string result = serializer.SerializeToString();
            response.ContentEncoding = Encoding.UTF8;
            response.Write(result);
        }

    }
}
