﻿using System.Reflection;
using System.Web.Mvc;

namespace Presentation.Web.UI.Controllers
{
    public class ResourceController : Controller
    {
        public FileStreamResult GetWebResourceUrl(string assemblyName, string typeName, string resourceName)
        {
            var assembly = Assembly.Load(assemblyName);
            var resource = assembly.GetManifestResourceStream(resourceName);
            return new FileStreamResult(resource, GetKnownContentType(resourceName));
        }

        private string GetKnownContentType(string resourceName)
        {
            switch (System.IO.Path.GetExtension(resourceName))
            {
                case ".css":
                    return "text/css";
                case ".gif":
                    return "image/gif";
                case ".png":
                    return "image/png";
                case ".js":
                    return "application/x-javascript";
                default:
                    return "text/plain";
            }
        }
    }
}
