using System.Web.Compilation;
using Application.MainModule.ResourceManagement;
using Infrastructure.CrossCutting.IoC;
using Infrastructure.CrossCutting.Resource;

namespace Presentation.Web.UI.MutiLanguage
{
    public class DBResourceProviderFactory : ResourceProviderFactory
    {
        public override IResourceProvider CreateGlobalResourceProvider(string classKey)
        {
            return new DBResourceProvider(classKey, IoCFactory.CurrentContainer.Resolve<IDBResourceSerivce>()); 
        }

        public override IResourceProvider CreateLocalResourceProvider(string virtualPath)
        {
            // we should always get a path from the runtime
            string classKey = virtualPath;
            if (!string.IsNullOrEmpty(virtualPath))
            {
                virtualPath = virtualPath.Remove(0, 1);
                classKey = virtualPath.Remove(0, virtualPath.IndexOf('/') + 1);
            }

            return new DBResourceProvider(classKey, IoCFactory.CurrentContainer.Resolve<IDBResourceSerivce>());
        }
    }
}