﻿using System;
using System.Web;
using DotNetOpenAuth;

namespace Presentation.Web.UI.Service
{
    public class EmbeddedResourceUrlService : IEmbeddedResourceRetrieval
    {
        private const string PathFormat = "{0}/Resource/GetWebResourceUrl?assemblyName={1}&typeName={2}&resourceName={3}";

        public Uri GetWebResourceUrl(Type someTypeInResourceAssembly, string manifestResourceName)
        {
            if (manifestResourceName.Contains("http"))
            {
                return new Uri(manifestResourceName);
            }
            else
            {
                var assembly = someTypeInResourceAssembly.Assembly;
                // HACK
                string completeUrl = HttpContext.Current.Request.Url.ToString();
                string host = completeUrl.Substring(0,
                    completeUrl.IndexOf(HttpContext.Current.Request.Url.AbsolutePath, System.StringComparison.Ordinal));

                var path = string.Format(PathFormat,
                            host,
                            HttpUtility.UrlEncode(assembly.FullName),
                            HttpUtility.UrlEncode(someTypeInResourceAssembly.ToString()),
                            HttpUtility.UrlEncode(manifestResourceName));
                return new Uri(path);
            }
        }
    }
}